---
title: SVG 2 support in Mozilla
slug: Web/SVG/SVG_2_support_in_Mozilla
tags:
  - Firefox
  - SVG
---
<div>{{SVGRef}}{{draft}}</div>

<p><a href="https://svgwg.org/svg2-draft/">SVG 2</a> is the next major version of the SVG standard, which is a complete rework of the SVG 1.2 draft.</p>

<p>Version 2 contains a lot of changes regarding the last stable version <a href="https://www.w3.org/TR/SVG11/">SVG 1.1</a>. Those changes are listed below including their support status within Mozilla applications.</p>

<h2 id="General">General</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>length</code> attribute and indexed property for list interfaces</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGElement("script")}} element in content model of all elements</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>initialize()</code>, <code>appendItem()</code>, <code>replaceItem()</code>, and <code>insertItemBefore()</code> on list objects making a copy of any list item being inserted that is already in another list</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td><code>crossorigin</code> attribute for {{SVGElement("image")}} and {{SVGElement("script")}} elements</td>
   <td>Not implemented yet (at least for <code>&lt;image&gt;</code>; {{bug("1240357")}})</td>
  </tr>
 </tbody>
</table>

<h2 id="Rendering_Model">Rendering Model</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td>SVG root and {{SVGElement("foreignObject")}} not <code>overflow:hidden</code> in UA style sheet</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Allow <code>{{cssxref("overflow")}}: auto;</code> to clip and show scroll bars</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Allow <code>{{cssxref("overflow")}}: scroll;</code> to show scroll bars on {{SVGElement("svg")}} elements</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>

<h2 id="Basic_Data_Types_and_Interfaces">Basic Data Types and Interfaces</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{domxref("DOMMatrix")}} or {{domxref("DOMMatrixReadOnly")}} instead of {{domxref("SVGMatrix")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{domxref("DOMRect")}} or {{domxref("DOMRectReadOnly")}} instead of {{domxref("SVGRect")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{domxref("DOMPoint")}} or {{domxref("DOMPointReadOnly")}} instead of {{domxref("SVGPoint")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Members of {{domxref("SVGStylable")}} and <code>SVGLangSpace</code> available in {{domxref("SVGElement")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{domxref("SVGGraphicsElement")}} instead of {{domxref("SVGLocatable")}} and {{domxref("SVGTransformable")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: khaki;">
   <td>{{domxref("SVGGeometryElement")}} with {{domxref("SVGGeometryElement.isPointInFill()")}} and {{domxref("SVGGeometryElement.isPointInStroke()")}} methods</td>
   <td>Partially implemented ({{bug("1239100")}}). The methods<br>
    <code>isPointInFill()</code> and <code>isPointInStroke()</code> are not implemented yet ({{bug(1325319)}}).</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td>{{domxref("SVGExternalResourcesRequired")}} removed</td>
   <td>Never implemented</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td><code>SVGElement.viewportElement</code> and <code>SVGElement.ownerSVGElement</code> nullable</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td><code>SVGElement.getPresentationAttribute()</code> removed</td>
   <td>Never implemented (prototype removed in {{bug("921456")}})</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td>{{domxref("SVGColor")}} and {{domxref("SVGICCColor")}} removed</td>
   <td>Never implemented</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td><code>SVGElement.focus()</code>, <code>SVGElement.blur()</code></td>
   <td>Not implemented ({{bug("778654")}})</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td><code>SVGElement.tabIndex</code></td>
   <td>Implemented ({{bug("778654")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>Document.activeElement</code></td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{domxref("GlobalEventHandlers")}} on {{domxref("SVGElement")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: khaki;">
   <td><code>options</code> dictionary attribute for <code>SVGGraphicsElement.getBBox()</code></td>
   <td>Implemented behind the preference <code>svg.new-getBBox.enabled</code> ({{bug("999964")}}, {{bug("1019326")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Allow leading and trailing whitespace in {{cssxref("length")}}, {{cssxref("angle")}}, {{cssxref("number")}} and {{cssxref("integer")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Form feed (<code>U+000C</code>) in whitespace</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>SVGElement.xmlbase</code>, <code>SVGElement.xmllang</code> and <code>SVGElement.xmlspace</code> removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>SVGViewSpec</code> removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>SVGElement.style</code> removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td><code>SVGGraphicsElement.getTransformToElement()</code> removed</td>
   <td>Not removed yet</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>SVGGraphicsElement.getCTM()</code> on the outermost element</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>animVal</code> attribute alias of <code>baseVal</code></td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>dataset</code> attribute for {{domxref("SVGElement")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td>Moved {{domxref("SVGGeometryElement.pathLength", "pathLength")}} attribute and {{domxref("SVGGeometryElement.getTotalLength()", "getTotalLength()")}} and {{domxref("SVGGeometryElement.getPointAtLength()", "getPointAtLength()")}} methods from {{domxref("SVGPathElement")}} to {{domxref("SVGGeometryElement")}}</td>
   <td>Implemented ({{bug("1239100")}})</td>
  </tr>
 </tbody>
</table>

<h2 id="Document_Structure">Document Structure</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: lightgreen;">
   <td><code>SVGSVGElement.suspendRedraw()</code>, <code>SVGSVGElement.unsuspendRedraw()</code>, and <code>SVGSVGElement.unsuspendRedrawAll()</code> deprecated</td>
   <td>Turned into no-ops ({{bug("734079")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>externalResourcesRequired</code> attribute removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>auto</code> value for <code>width</code> and <code>height</code> in {{SVGElement("image")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>referencing entire document with {{SVGElement("use")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td><code>lang</code> attribute on {{SVGElement("desc")}} and {{SVGElement("title")}}</td>
   <td>Implemented ({{bug("721920")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>CSS transforms on outermost {{SVGElement("svg")}} not affecting <code>SVGSVGElement.currentScale</code> or <code>SVGSVGElement.currentTranslate</code></td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>rootElement</code> attribute deprecated</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{domxref("SVGElementInstance")}} and {{domxref("SVGElementInstanceList")}} and corresponding attributes on {{domxref("SVGUseElement")}} removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGElement("use")}} event flow following Shadow DOM spec.</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>auto</code> as initial value for <code>width</code> and <code>height</code> attributes of {{SVGElement("svg")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>baseProfile</code> and <code>version</code> attributes removed from {{SVGElement("svg")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td><code>SVGSVGElement.forceRedraw()</code> deprecated</td>
   <td>Turned into a no-op ({{bug("733764")}})</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td><code>SVGSVGElement.deselectAll()</code> deprecated</td>
   <td>Not yet deprecated ({{bug("1302705")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGElement("switch")}} not affecting {{SVGElement("style")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>requiredFeatures</code> attribute removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: khaki;">
   <td><code>SVGSVGElement.currentView</code> and <code>SVGSVGElement.useCurrentView</code> removed</td>
   <td><code>SVGSVGElement.currentView</code> was never implemented, <code>SVGSVGElement.useCurrentView</code> not removed yet ({{bug("1174097")}})</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td>{{domxref("SVGUnknownElement")}}</td>
   <td>Not implemented ({{bug("1239218")}})</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td><code>lang</code> attribute without namespace</td>
   <td>Implemented ({{bug("721920")}})</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td><code>SVGSVGElement.viewport</code> removed</td>
   <td>Never implemented</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>xml:base</code> attribute removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Reorder descendent elements of {{SVGElement("switch")}} having <code>systemLanguage</code> attribute according to <code>allowReorder</code> SMIL attribute</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Made {{SVGElement("tspan")}} and {{SVGElement("textPath")}} graphics elements</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Allow <code>x</code>, <code>y</code>, <code>width</code>, and <code>height</code> on {{SVGElement("symbol")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Made {{SVGElement("use")}} element shadow trees consistent with Shadow DOM spec</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Role mapping of {{SVGElement("a")}} element depending on whether it is a valid link</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>ARIA state and property attributes animatable</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>

<h2 id="Styling">Styling</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>contentStyleType</code> attribute removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td>{{domxref("LinkStyle")}} on {{domxref("SVGStyleElement")}}</td>
   <td>Implemented ({{bug("1239128")}} {{geckoRelease("46.0")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Inner {{SVGElement("svg")}}s and {{SVGElement("foreignObjects")}}s not <code>{{cssxref("overflow")}}: hidden;</code> in UA style sheet</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>{{cssxref("overflow")}}: hidden;</code> on {{SVGElement("hatch")}} in UA style sheet</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>0 0</code> as default value of {{cssxref("transform-origin")}} except root {{SVGElement("svg")}} and <code>&lt;svg&gt;</code> children of {{SVGElement("foreign")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Use of {{cssxref("white-space")}} instead of deprecated <code>xml:space</code> attribute in UA style sheet</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{cssxref("@font-face")}}, {{cssxref("::first-letter")}} and {{cssxref("::first-line")}} on {{SVGElement("text")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>SVG and HTML style sheets in HTML document with inline SVG applying to whole document content</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Presentation attributes on any SVG namespaced element</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Display behavior of {{SVGElement("style")}} defined via UA style sheet</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>!important</code> user agent style rules controlling never-rendered elements</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>:focus</code> and <code>::selection</code> styles</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>

<h2 id="Geometry">Geometry</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>x</code> and <code>y</code> attributes removed from {{SVGElement("pattern")}} and {{SVGElement("filter")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td><code>auto</code> value of <code>width</code> and <code>height</code> computes to <code>0</code> but <code>100%</code> on {{SVGElement("svg")}}</td>
   <td>Not implemented</td>
  </tr>
 </tbody>
</table>

<h2 id="Coordinate_Systems_Transformations_and_Units">Coordinate Systems, Transformations and Units</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td>Exception for bad values on <code>SVGMatrix.skewX()</code> and <code>SVGMatrix.skewY()</code></td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Bounding box for element with no position at (<code>0, 0</code>)</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td><code>defer</code> keyword removed from <code>preserveAspectRatio</code> attribute</td>
   <td>Removed ({{bug("1280425")}})</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td>Added <code>non-scaling-size</code>, <code>non-rotation</code> and <code>fixed-position</code> keywords for {{cssxref("vector-effect")}} property</td>
   <td>Not implemented yet ({{bug("1303567")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{cssxref("vector-effect")}} has no effect within 3D rendering context</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Consider {{cssxref("clip")}} and {{cssxref("overflow")}} on SVG document referenced by {{SVGElement("image")}}</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>

<h2 id="Paths">Paths</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>B</code> and <code>b</code> path commands</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>Z</code> and <code>z</code> path commands to add path coordinate data to previous command</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Not render {{SVGElement("path")}}, {{SVGElement("polygon")}} and {{SVGElement("polyline")}} with no data</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>SVGPathSeg*</code>, {{domxref("SVGAnimatedPathData")}} and related methods removed from {{domxref("SVGPathElement")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGAttr("d")}} attribute as CSS property</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>

<h2 id="Basic_Shapes">Basic Shapes</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGAttr("pathLength")}} attribute for all basic shapes</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>SVGAnimatedPoints.animatedPoints</code> as alias of <code>SVGAnimatedPoints.points</code></td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Auto behavior for <code>rx</code> and <code>ry</code> in {{SVGElement("ellipse")}}</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>

<h2 id="Text">Text</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: salmon;">
   <td>{{cssxref("text-decoration-fill")}} and {{cssxref("text-decoration-stroke")}} properties</td>
   <td>Not implemented yet ({{bug("1303569")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>inline-size</code> attribute for {{SVGElement("text")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{cssxref("shape-inside")}} property</td>
   <td>Inplementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{cssxref("shape-subtract")}} property</td>
   <td>Inplementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{cssxref("white-space")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Deprecated <code>xml:space</code> attribute</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{cssxref("kerning")}} property removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td><code>path</code> attribute for {{SVGElement("textPath")}}</td>
   <td>Implemented ({{bug("1446617")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Reference basic shapes to {{SVGElement("textPath")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td><code>side</code> attribute for {{SVGElement("textPath")}}</td>
   <td>Implemented ({{bug("1446650")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Render characters for one loop of a single closed path, effected by the {{SVGAttr("startOffset")}} attribute and {{cssxref("text-anchor")}} property</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGElement("tref")}} removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td>{{SVGElement("altGlyph")}}, {{SVGElement("altGlyphDef")}}, {{SVGElement("altGlyphItem")}} and {{SVGElement("glyphRef")}} removed</td>
   <td><code>&lt;altGlyph&gt;</code>, <code>&lt;altGlyphDef&gt;</code> and <code>&lt;altGlyphItem&gt;</code> removed ({{bug("1260032")}}), <code>&lt;glyphRef&gt;</code> never really implemented ({{bug("1302693")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>SVGTextContentElement.selectSubString()</code> deprecated</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>getComputedTextLength()</code> not including <code>dx</code> and <code>dy</code> values</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Text in non-rendered elements not included in addressable characters</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Unknown elements in text render as unpositioned spans</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Offset distances of text positioned along a transformed path measured in text elements coordinate system</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>

<h2 id="Embedded_Content">Embedded Content</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGElement("video")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGElement("audio")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGElement("iframe")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGElement("canvas")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGElement("source")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGElement("track")}}</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>

<h2 id="Painting">Painting</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: lightgreen;">
   <td>{{cssxref("paint-order")}}</td>
   <td>Implemented ({{bug("828805")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{cssxref("will-change")}} instead of <code>buffered-rendering</code></td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td><code>context-fill</code> and <code>context-stroke</code> paint values</td>
   <td>Implemented ({{bug("719286")}} {{geckoRelease("18.0")}} and {{bug("798843")}} {{geckoRelease("26.0")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>child</code> keyword for <code>&lt;paint&gt;</code> values and marker properties</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: khaki;">
   <td>{{cssxref("vector-effect")}} property</td>
   <td>Only <code>none</code> and <code>non-scaling-stroke</code> values are supported ({{bug("528332")}} {{geckoRelease("15")}}, {{bug("1265666")}})</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td><code>arcs</code> value for {{cssxref("stroke-linejoin")}}</td>
   <td>Not implemented ({{bug("1239142")}})</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td><code>auto-start-reverse</code> value for {{SVGElement("marker")}}'s <code>orient</code> attribute</td>
   <td>Implemented ({{bug("879659")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{domxref("SVGPaint")}} removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{cssxref("fill")}} and {{cssxref("stroke")}} taking multiple paints</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td>{{cssxref("z-index")}}</td>
   <td>Not implemented ({{bug("360148")}}</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>child({{cssxref("integer")}})</code> paint value</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Display of zero-length subpaths depends on {{SVGAttr("stroke-linecap")}} attribute</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Markers on all shapes</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGElement("marker")}} element display defined in UA style sheet</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Only single paints for fills and strokes</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>

<h2 id="Color">Color</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td>Color managed images</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>RGBA, HSL, LAB, ICC named colors and device colors</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{cssxref("color-profile")}} removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGElement("color-profile")}} removed</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>

<h2 id="Paint_Servers">Paint Servers</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: salmon;">
   <td>{{SVGElement("solidcolor")}} (renamed <code>solidColor</code>)</td>
   <td>Not implemented ({{bug("1177032")}})</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td><code>fr</code> attribute for {{SVGElement("radialGradient")}}</td>
   <td>Not implemented ({{bug("1240275")}})</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td>{{SVGElement("mesh")}} (renamed <code>meshGradient</code>)</td>
   <td>Not implemented ({{bug("1238882")}})</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td>{{SVGElement("meshrow")}} (renamed <code>meshRow</code>)</td>
   <td>Not implemented ({{bug("1238882")}})</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td>{{SVGElement("meshpatch")}} (renamed <code>meshPatch</code>)</td>
   <td>Not implemented ({{bug("1238882")}})</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td>{{SVGElement("hatch")}}</td>
   <td>Not implemented ({{bug("1239147")}})</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td>{{SVGElement("hatchpath")}} (renamed <code>hatchPath</code>)</td>
   <td>Not implemented ({{bug("1239147")}})</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td>Display behavior of paint server elements defined by UA style sheet</td>
   <td>Not implemented</td>
  </tr>
 </tbody>
</table>

<h2 id="Clipping_Masking_and_Compositing">Clipping, Masking, and Compositing</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{cssxref("overflow")}} respected on outermost {{SVGElement("svg")}} elements inline in HTML</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>

<h2 id="Interactivity">Interactivity</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: lightgreen;">
   <td>{{SVGAttr("tabindex")}} attribute</td>
   <td>Implemented ({{bug("778654")}})</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td><code>bounding-box</code> on {{cssxref("pointer-events")}}</td>
   <td>Not implemented ({{bug("945187")}})</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td><code>load</code>, <code>abort</code>, <code>error</code>, and <code>unload</code> instead of <code>SVGLoad</code>, <code>SVGAbort</code>, <code>SVGError</code>, and <code>SVGUnload</code></td>
   <td>Not implemented ({{bug("620002")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Only structurally external elements and outermost {{SVGElement("svg")}} element fire <code>load</code> events</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>resize</code> and <code>scroll</code> instead of <code>SVGResize</code> and <code>SVGScroll</code></td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>DOMActivate</code> removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>focusin</code> and <code>focusout</code> instead of <code>DOMFocusIn</code> and <code>DOMFocusOut</code></td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Keyboard events</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Mutation events removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>SVGZoomEvent</code> removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGElement("cursor")}} element deprecated</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>

<h2 id="Linking">Linking</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td>Link SVG resources with fragment identifiers</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>xlink:type</code>, <code>xlink:role</code>, <code>xlink:arcrole</code>, <code>xlink:show</code>, and <code>xlink:actuate</code> attributes removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: salmon;">
   <td><code>xlink:href</code> attribute deprecated in favor of <code>href</code></td>
   <td>Implemented ({{bug("1245751")}})</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>xlink:title</code> attribute deprecated in favor of child {{SVGElement("title")}}</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Spaces in SVG view fragments</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>pixel:</code> and <code>percent:</code> spatial media fragments</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Linking to {{SVGElement("view")}} elements does not cause implicit box transformation to show nearest ancestor {{SVGElement("svg")}} element</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Unspecified SVG view fragment parameters don't cause corresponding attributes to be reset to initial values</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td><code>viewTarget</code> attribute of {{SVGElement("view")}} and corresponding SVG view fragment parameter removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>Fragment-only URLs are always same-document</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: lightgreen;">
   <td>Additional attributes on {{SVGElement("a")}}</td>
   <td>Implemented ({{bug("1451823")}})</td>
  </tr>
 </tbody>
</table>

<h2 id="Scripting">Scripting</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGAttr("contentScriptType")}} removed</td>
   <td>Implementation status unknown</td>
  </tr>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{domxref("AnimationEvents.onload")}} removed</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>

<h2 id="Fonts">Fonts</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td>{{SVGElement("font")}}, {{SVGElement("glyph")}}, {{SVGElement("missing-glyph")}}, {{SVGElement("hkern")}}, {{SVGElement("vkern")}}, {{SVGElement("font-face")}}, {{SVGElement("font-face-src")}}, {{SVGElement("font-face-uri")}}, {{SVGElement("font-face-format")}}, and {{SVGElement("font-face-name")}} and corresponding IDL interfaces removed</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>

<h2 id="Extensibility_chapter">Extensibility chapter</h2>

<table class="standard-table" style="border-collapse: separate;">
 <thead>
  <tr>
   <th scope="col">Change</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr style="color: black; background-color: #cccccc;">
   <td>Made {{SVGElement("foreignObject")}} graphics element</td>
   <td>Implementation status unknown</td>
  </tr>
 </tbody>
</table>
